#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>

int main(int argc, char* argv[]) {
	int fd;
	unsigned char buf[3];

	if (argc < 2) {
		fprintf(stderr, "File name missing!\n");
		return 99;
	}
	fd = open(argv[1], O_RDWR);
	if (fd == -1) {
		fprintf(stderr, "Cannot open %s: %m\n", argv[1]);
		return 98;
	}
	if (lseek(fd, 564792, SEEK_SET) != 564792) {
		fprintf(stderr, "Cannot seek: %m\n");
		close(fd);
		return 97;
	}
	if (read(fd, buf, 3) != 3) {
		fprintf(stderr, "Cannot read... Damaged VMware?\n");
		close(fd);
		return 96;
	}
	if (!memcmp(buf, "\x03\x72\x20", 3)) {
		printf("Image already patched\n");
		close(fd);
		return 0;
	}
	if (memcmp(buf, "\x03\x75\x20", 3)) {
		printf("Sorry, unknown image\n");
		close(fd);
		return 2;
	}
	if (lseek(fd, 564793, SEEK_SET) != 564793) {
		fprintf(stderr, "Cannot seek for write: %m\n");
		close(fd);
		return 95;
	}
	buf[0] = 0x72;
	if (write(fd, buf, 1) != 1) {
		fprintf(stderr, "Oops! Write failed! Please, reinstall vmware\n");
		close(fd);
		return 94;
	}
	if (lseek(fd, 564792, SEEK_SET) != 564792) {
		fprintf(stderr, "Cannot seek: %m\n");
		close(fd);
		return 93;
	}
	if (read(fd, buf, 3) != 3) {
		fprintf(stderr, "Cannot read... Damaged VMware?\n");
		close(fd);
		return 92;
	}
	if (!memcmp(buf, "\x03\x72\x20", 3)) {
		printf("Image patched\n");
		close(fd);
		return 0;
	}
	if (memcmp(buf, "\x03\x75\x20", 3)) {
		printf("Sorry, image was damaged by patch. Reinstall vmware.\n");
		close(fd);
		return 91;
	}
	printf("Uhhh... Write failed?\n");
	return 1;
}

